NIX.CONF(5)

NAME
nix.conf - Nix configuration file

DESCRIPTION

A number of persistent settings of Nix are stored in the file sysconfdir/nix/nix.conf. This file is a list of name = value pairs, one per line. Comments start with a # character. Here is an example configuration file:

    gc-keep-outputs = true       # Nice for developers
    gc-keep-derivations = true   # Idem
    env-keep-derivations = false

You can override settings using the --option flag, e.g. --option gc-keep-outputs false.

The following settings are currently available:

gc-keep-outputs
    If true, the garbage collector will keep the outputs of non-garbage derivations. If false (default), outputs will be deleted unless they are GC roots themselves (or reachable from other roots).

    In general, outputs must be registered as roots separately. However, even if the output of a derivation is registered as a root, the collector will still delete store paths that are used only at build time (e.g., the C compiler, or source tarballs downloaded from the network). To prevent it from doing so, set this option to true.

gc-keep-derivations
    If true (default), the garbage collector will keep the derivations from which non-garbage store paths were built. If false, they will be deleted unless explicitly registered as a root (or reachable from other roots).

    Keeping derivation around is useful for querying and traceability (e.g., it allows you to ask with what dependencies or options a store path was built), so by default this option is on. Turn it off to save a bit of disk space (or a lot if gc-keep-outputs is also turned on).

env-keep-derivations
    If false (default), derivations are not stored in Nix user environments. That is, the derivation any build-time-only dependencies may be garbage-collected.

    If true, when you add a Nix derivation to a user environment, the path of the derivation is stored in the user environment. Thus, the derivation will not be garbage-collected until the user environment generation is deleted (nix-env --delete-generations). To prevent build-time-only dependencies from being collected, you should also turn on gc-keep-outputs.

    The difference between this option and gc-keep-derivations is that this one is “sticky”: it applies to any user environment created while this option was enabled, while gc-keep-derivations only applies at the moment the garbage collector is run.

build-max-jobs
    This option defines the maximum number of jobs that Nix will try to build in parallel. The default is 1. You should generally set it to the number of CPUs in your system (e.g., 2 on an Athlon 64 X2). It can be overridden using the --max-jobs (-j) command line switch.

build-cores
    Sets the value of the NIX_BUILD_CORES environment variable in the invocation of builders. Builders can use this variable at their discretion to control the maximum amount of parallelism. For instance, in Nixpkgs, if the derivation attribute enableParallelBuilding is set to true, the builder passes the -jN flag to GNU Make. It can be overridden using the --cores command line switch and defaults to 1. The value 0 means that the builder should use all available CPU cores in the system.

build-max-silent-time
    This option defines the maximum number of seconds that a builder can go without producing any data on standard output or standard error. This is useful (for instance in an automated build system) to catch builds that are stuck in an infinite loop, or to catch remote builds that are hanging due to network problems. It can be overridden using the --max-silent-time command line switch.

    The value 0 means that there is no timeout. This is also the default.

build-timeout
    This option defines the maximum number of seconds that a builder can run. This is useful (for instance in an automated build system) to catch builds that are stuck in an infinite loop but keep writing to their standard output or standard error. It can be overridden using the --timeout command line switch.

    The value 0 means that there is no timeout. This is also the default.

build-max-log-size
    This option defines the maximum number of bytes that a builder can write to its stdout/stderr. If the builder exceeds this limit, it’s killed. A value of 0 (the default) means that there is no limit.

build-users-group
    This options specifies the Unix group containing the Nix build user accounts. In multi-user Nix installations, builds should not be performed by the Nix account since that would allow users to arbitrarily modify the Nix store and database by supplying specially crafted builders; and they cannot be performed by the calling user since that would allow him/her to influence the build result.

    Therefore, if this option is non-empty and specifies a valid group, builds will be performed under the user accounts that are a member of the group specified here (as listed in /etc/group). Those user accounts should not be used for any other purpose!

    Nix will never run two builds under the same user account at the same time. This is to prevent an obvious security hole: a malicious user writing a Nix expression that modifies the build result of a legitimate Nix expression being built by another user. Therefore it is good to have as many Nix build user accounts as you can spare. (Remember: uids are cheap.)

    The build users should have permission to create files in the Nix store, but not delete them. Therefore, /nix/store should be owned by the Nix account, its group should be the group specified here, and its mode should be 1775.

    If the build users group is empty, builds will be performed under the uid of the Nix process (that is, the uid of the caller if NIX_REMOTE is empty, the uid under which the Nix daemon runs if NIX_REMOTE is daemon). Obviously, this should not be used in multi-user settings with untrusted users.

build-use-sandbox
    If set to true, builds will be performed in a sandboxed environment, i.e., they’re isolated from the normal file system hierarchy and will only see their dependencies in the Nix store, the temporary build directory, private versions of /proc, /dev, /dev/shm and /dev/pts (on Linux), and the paths configured with the build-sandbox-paths option. This is useful to prevent undeclared dependencies on files in directories such as /usr/bin. In addition, on Linux, builds run in private PID, mount, network, IPC and UTS namespaces to isolate them from other processes in the system (except that fixed-output derivations do not run in private network namespace to ensure they can access the network).

    Currently, sandboxing only work on Linux and Mac OS X. The use of a sandbox requires that Nix is run as root (so you should use the “build users” feature to perform the actual builds under different users than root).

    If this option is set to relaxed, then fixed-output derivations and derivations that have the __noChroot attribute set to true do not run in sandboxes.

    The default is false.

build-sandbox-paths
    A list of paths bind-mounted into Nix sandbox environments. You can use the syntax target=source to mount a path in a different location in the sandbox; for instance, /bin=/nix-bin will mount the path /nix-bin as /bin inside the sandbox. If source is followed by ?, then it is not an error if source does not exist; for example, /dev/nvidiactl? specifies that /dev/nvidiactl will only be mounted in the sandbox if it exists in the host filesystem.

    Depending on how Nix was built, the default value for this option may be empty or provide /bin/sh as a bind-mount of bash.

build-extra-sandbox-paths
    A list of additional paths appended to build-sandbox-paths. Useful if you want to extend its default value.

build-use-substitutes
    If set to true (default), Nix will use binary substitutes if available. This option can be disabled to force building from source.

build-fallback
    If set to true, Nix will fall back to building from source if a binary substitute fails. This is equivalent to the --fallback flag. The default is false.

build-cache-failure
    If set to true, Nix will “cache” build failures, meaning that it will remember (in its database) that a derivation previously failed. If you then try to build the derivation again, Nix will immediately fail rather than perform the build again. Failures in fixed-output derivations (such as fetchurl calls) are never cached. The “failed” status of a derivation can be cleared using nix-store --clear-failed-paths. By default, failure caching is disabled.

build-keep-log
    If set to true (the default), Nix will write the build log of a derivation (i.e. the standard output and error of its builder) to the directory /nix/var/log/nix/drvs. The build log can be retrieved using the command nix-store -l path.

build-compress-log
    If set to true (the default), build logs written to /nix/var/log/nix/drvs will be compressed on the fly using bzip2. Otherwise, they will not be compressed.

use-binary-caches
    If set to true (the default), Nix will check the binary caches specified by binary-caches and related options to obtain binary substitutes.

binary-caches
    A list of URLs of binary caches, separated by whitespace. The default is https://cache.nixos.org.

binary-caches-files
    A list of names of files that will be read to obtain additional binary cache URLs. The default is /nix/var/nix/profiles/per-user/username/channels/binary-caches/*. Note that when you’re using the Nix daemon, username is always equal to root, so Nix will only use the binary caches provided by the channels installed by root. Do not set this option to read files created by untrusted users!

trusted-binary-caches
    A list of URLs of binary caches, separated by whitespace. These are not used by default, but can be enabled by users of the Nix daemon by specifying --option binary-caches urls on the command line. Unprivileged users are only allowed to pass a subset of the URLs listed in binary-caches and trusted-binary-caches.

extra-binary-caches
    Additional binary caches appended to those specified in binary-caches and binary-caches-files. When used by unprivileged users, untrusted binary caches (i.e. those not listed in trusted-binary-caches) are silently ignored.

signed-binary-caches
    If set to *, Nix will only download binaries if they are signed using one of the keys listed in binary-cache-public-keys.

binary-cache-public-keys
    A whitespace-separated list of public keys corresponding to the secret keys trusted to sign binary caches. For example: cache.nixos.org-1:6NCHdD59X431o0gWypbMrAURkbJ16ZPMQFGspcDShjY= hydra.nixos.org-1:CNHJZBh9K4tP3EKF6FkkgeVYsS3ohTl+oS0Qa8bezVs=.

binary-caches-parallel-connections
    The maximum number of parallel HTTP connections used by the binary cache substituter to get NAR info files. This number should be high to minimise latency. It defaults to 25.

verify-https-binary-caches
    Whether HTTPS binary caches are required to have a certificate that can be verified. Defaults to true.

force-manifest
    If this option is set to false (default) and a Nix channel provides both a manifest and a binary cache, only the binary cache will be used. If set to true, the manifest will be fetched as well. This is useful if you want to use binary patches (which are currently not supported by binary caches).

netrc-file
    If set to an absolute path to a netrc file, Nix will use the HTTP authentication credentials in this file when trying to download from a remote host through HTTP or HTTPS. Defaults to $NIX_CONF_DIR/netrc.

    The netrc file consists of a list of accounts in the following format:

        machine my-machine
        login my-username
        password my-password

    For the exact syntax, see the curl documentation.[1]

system
    This option specifies the canonical Nix system name of the current installation, such as i686-linux or powerpc-darwin. Nix can only build derivations whose system attribute equals the value specified here. In general, it never makes sense to modify this value from its default, since you can use it to ‘lie’ about the platform you are building on (e.g., perform a Mac OS build on a Linux machine; the result would obviously be wrong). It only makes sense if the Nix binaries can run on multiple platforms, e.g., ‘universal binaries’ that run on powerpc-darwin and i686-darwin.

    It defaults to the canonical Nix system name detected by configure at build time.

fsync-metadata
    If set to true, changes to the Nix store metadata (in /nix/var/nix/db) are synchronously flushed to disk. This improves robustness in case of system crashes, but reduces performance. The default is true.

auto-optimise-store
    If set to true, Nix automatically detects files in the store that have identical contents, and replaces them with hard links to a single copy. This saves disk space. If set to false (the default), you can still run nix-store --optimise to get rid of duplicate files.

connect-timeout
    The timeout (in seconds) for establishing connections in the binary cache substituter. It corresponds to curl’s --connect-timeout option.

log-servers
    A list of URL prefixes (such as http://hydra.nixos.org/log) from which nix-store -l will try to fetch build logs if they’re not available locally.

trusted-users
    A list of names of users (separated by whitespace) that have additional rights when connecting to the Nix daemon, such as the ability to specify additional binary caches, or to import unsigned NARs. You can also specify groups by prefixing them with @; for instance, @wheel means all users in the wheel group. The default is root.

        Warning
        The users listed here have the ability to compromise the security of a multi-user Nix store. For instance, they could install Trojan horses subsequently executed by other users. So you should consider carefully whether to add users to this list.

allowed-users
    A list of names of users (separated by whitespace) that are allowed to connect to the Nix daemon. As with the trusted-users option, you can specify groups by prefixing them with @. Also, you can allow all users by specifying *. The default is *.

    Note that trusted users are always allowed to connect.

restrict-eval
    If set to true, the Nix evaluator will not allow access to any files outside of the Nix search path (as set via the NIX_PATH environment variable or the -I option). The default is false.

pre-build-hook
    If set, the path to a program that can set extra derivation-specific settings for this system. This is used for settings that can't be captured by the derivation model itself and are too variable between different versions of the same system to be hard-coded into nix.

    The hook is passed the derivation path and, if sandboxes are enabled, the sandbox directory. It can then modify the sandbox and send a series of commands to modify various settings to stdout. The currently recognized commands are:

    extra-sandbox-paths
        Pass a list of files and directories to be included in the sandbox for this build. One entry per line, terminated by an empty line. Entries have the same format as build-sandbox-paths.

build-repeat
    How many times to repeat builds to check whether they are deterministic. The default value is 0. If the value is non-zero, every build is repeated the specified number of times. If the contents of any of the runs differs from the previous ones, the build is rejected and the resulting store paths are not registered as “valid” in Nix’s database.

AUTHOR

Eelco Dolstra
LogicBlox
    Author

COPYRIGHT
Copyright © 2004-2014 Eelco Dolstra

NOTES

1.  the
        curl documentation.
    https://ec.haxx.se/usingcurl-netrc.html